**************************
* PAUSEPRN.PRG - PRINTER PAUSE FUNCTION
* Authors - Luis Castro/Jeff Presley
* Adapted/revised with permission by Lee Thompson
* Revision Date:  04/14/90
*
* NOTE:  Incorporate into proc/function file - If compiling as
*        a single file, this file MUST be renamed!  Cannot
*        have <filename> the same as a called function/proc.
*
* NOTE:  Calling program needs CHOICE = "P" (REPORT/LABEL TO
*        <S>CREEN, <P>RINT, <D>ISK e.g.), pprinter = choice
*        = "P" or something similar (if used) -  otherwise
*        modify to suit yourself.  "P" acts as a toggle to
*        control printing.
*
* NOTE:  Calling program needs PRIVATE variable ReturnKey
*        declared and STORE " " to ReturnKey.  ReturnKey acts
*        as an indicator when none of the choices are selected,
*        i.e., CHOICE = " "
*
* This function is based on the feature of the REPORT/LABEL
* command which checks the "FOR/WHILE" conditions before each
* record is printed.
*
* Syntax:  REPORT/LABEL form <filename> [conditions] WHILE PausePRN(pprinter)
**************************


FUNCTION PausePRN
PARAMETER pprinter  && See notes in heading
   IF INKEY() = 0   && No key was pressed and
      RETURN .T.    && Printing continues WHILE .T.
   ENDIF

   * If a key was pressed
   PRIVATE choice,crow,numRECS
   SET ESCAPE OFF
   choice = "*"
   crow = ROW()
   DO SayLine WITH crow,;
      "PAUSED!  C)ontinue, B)ackup-and-continue, Q)uit "
   DO GetKey WITH choice,"CBQ"+Returnkey
   @ crow,0 CLEAR
      * --- continue
   IF choice = "C"
      IF pprinter
         EJECT
      ELSE
         CLEAR
      ENDIF
   ENDIF
   IF choice = "B"
      * ---Backup and continue.
      numRECS = 0
      @ crow,0 CLEAR
      @ crow,0 SAY "Enter number of records to backup";
             GET numRECS PICTURE "@Z 999" RANGE 0,999
      READ
      @ crow,0 CLEAR
      IF numRECS > 0
         SKIP -numRECS
      ENDIF
      IF pprinter
         EJECT
      ELSE
         CLEAR
      ENDIF
   ENDIF
   SET ESCAPE ON
   * ---Quit report when "Q" is pressed (RETURN .F.).
RETURN (choice <> "Q")

* EOF - FUNCTION PausePRN()


PROCEDURE GetKey
PARAMETER choice,keychars
PRIVATE keycode
   choice = "*"
   DO WHILE .NOT. (choice $ keychars)
      keycode = INKEY()
      IF keycode > 0
         choice = UPPER(CHR(keycode))
      ENDIF
   ENDDO
RETURN

*EOP - PROCEDURE GetKey


PROCEDURE SayLine
PARAMETER row,strg
   @ row,0 CLEAR
   @ row,0 SAY strg
RETURN

*EOP - PROCEDURE SayLine

